 /**
 * Write a description of class Producto here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 * -idp:int
 */
import java.util.*;

public class Producto
{
    // instance variables - replace the example below with your own
    private int idp;  // Clave primaria de Producto
    private String descripcion;
    private double precio;
    private int stock;
    
    /**
     * Contructor String descriopcion de producto
     */
    public Producto(String descripcion)
    {
        this(0,descripcion);
    }
    
    /**
     * Contructor int Codigo de producto
     */
    public Producto(int idp) {
        this(idp,"");
    }
    
    /**
     * Contructor int Codigo String Descripcion de producto
     */
    public Producto(int idp,String descripcion)
    {
        this(idp,descripcion,0.0);
    }
    
    /**
     * Contructor inr Codigo String Descripcion double Precio de producto
     */
    public Producto(int idp,String descripcion,double precio)
    {
        setIdp(idp);
        setDescripcion(descripcion);
        setPrecio(precio);
    }
    
    /**
     * Constructor int codigo  String descripcion  Double precio int stock de producto
     */
    public Producto(int idp,String descripcion,double precio,int stock)
    {
        // initialise instance variables
        this.idp = idp;
        this.descripcion = descripcion;
        this.precio = precio;
        this.stock = stock; 
    }

    /**
     * @return     retorna id de producto 
     */
    public int getIdp()
    {
        // put your code here
        return this.idp;
    }
    
    /**
     * @return     retorna descripcion de producto 
     */
    public String getDescripcion()
    {
        // put your code here
        return this.descripcion;
    }
    
    /**
     * @return     retorna precio de producto 
     */
    public double getPrecio()
    {
        // put your code here
        return this.precio;
    }
    
    /**
     * @return     retorna stock de producto 
     */
    public int getStock()
    {
        // put your code here
        return this.stock;
    }
    
     /**
     * @param   ingreso de idp tipo de dato int 
     */
    public void setIdp(int idp)
    {
        // put your code here
        this.stock = idp;
    }
    
     /**
     * @param   ingreso de descripcion tipo de dato String 
     */
    public void setDescripcion(String descripcion)
    {
        // put your code here
        this.descripcion = descripcion;
    }
    
     /**
     * @param   ingreso de precio tipo de dato double
     */
    public void setPrecio(double precio)
    {
        // put your code here
        this.precio = precio;
    }
    
    /**
     * 
     */
    private void setStock(int stock){
        this.stock += stock;
    }
    /**
     * @param   ingreso de stock tipo de dato entero
     */
    public void addStock(int stock) { 
        setStock(stock);
    }
    
    
     /**
     * Sobre escribe metodo toString para devolver en string todos sus campos correspondientes a cliente
     * @return String datos de cliente
     */
    @Override
    public String toString(){
        //return ">Idp: "+getIdp()+" >Descripcion : "+getDescripcion()+" >Precio : "+getPrecio()+" >Stock : "+getStock();
        return getDescripcion();
    }
    
     public void delStock (int Stock){
    this.stock = -stock;
   }
   
    /**
     * Código que añadimos a la clase Producto. Sobreescritura del método equals
     * @return true or false
     */
    @Override
    public boolean equals (Object obj) {
        if (obj == null){return false;}
        if (obj == this){return true;}
           else if ( (obj instanceof Producto) && (((Producto)obj).getIdp() == this.idp)) { return true;
            } else { return false; }
    }
    /**
     * Si el metodo hascode es invocado en multiples ocaciones durante la ejecucion de una aplicacion, este debe
     * regresar consistentemente el mismo valor entero.
     * Si dos objetos son iguales segun el  metodo equals entonces la llamada al metodo hash code debe regresar el
     * mismo hashcode.
     * El metodo hasdcode de retornar en Producto es idp
     */
    @Override
    public int hashCode(){
        return idp;
    }
}
