import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.sql.*;
import java.text.*;

/**
 * View principal de la aplicacion
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AppView extends WindowAdapter {
    private JFrame fr = new JFrame("SISTEMA FACTURACION");
    private JMenuBar mb = new JMenuBar();
    private JMenu mcli = new JMenu("Cliente");
    private JMenu mpro = new JMenu("Producto");
    private JMenu mfac = new JMenu("Factura");
    private JMenuItem micli1 = new JMenuItem("Alta");
    private JMenuItem micli2 = new JMenuItem("Consulta 1");
    private JMenuItem micli3 = new JMenuItem("Consulta 2");
    private JMenuItem micli4 = new JMenuItem("Consulta 3");
    private JMenuItem mipro1 = new JMenuItem("Alta");
    private JMenuItem mifac1 = new JMenuItem("Nueva Factura");
    private Login log = null;
    private JPanel pNorth = new JPanel();
    private JPanel pSouth = new JPanel();
    private JPanel pEast = new JPanel();
    private JPanel pWest = new JPanel();
    private JPanel pCenter = new JPanel();
    

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
    }
    public AppView(Login l) {
        log = l;
        //
        // agrego menu items a menues
        mcli.add(micli1);
        mcli.add(micli2);
        mcli.add(micli3);
        mcli.add(micli4);
        mpro.add(mipro1);
        mfac.add(mifac1);
        // agrego menues a menu bar
        mb.add(mcli);
        mb.add(mpro);
        mb.add(mfac);
        fr.getContentPane().add("North",pNorth);
        fr.getContentPane().add("South",pSouth);
        fr.getContentPane().add("East",pEast);
        fr.getContentPane().add("West",pWest);
        fr.getContentPane().add("Center",pCenter);
        // indico menu del JFrame
        fr.setJMenuBar(mb);
        
        // initialise instance variables
        fr.addWindowListener(this);
        micli1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono alta de cliente!");
                removeComponent();
                JTextField txtCodigo = new JTextField("");
                JTextField txtDescr = new JTextField("");
                JTextField txtSaldo = new JTextField("0.0");
                JLabel lblCodigo = new JLabel("Codigo");
                JLabel lblDescr = new JLabel("Descripcion");
                JLabel lblSaldo = new JLabel("Saldo");
                JButton btn = new JButton("Grabar");
                JPanel pfrm = new JPanel(new SpringLayout());
                lblCodigo.setLabelFor(txtCodigo);
                lblDescr.setLabelFor(txtDescr);
                lblSaldo.setLabelFor(txtSaldo);
                pfrm.add(lblCodigo);
                pfrm.add(txtCodigo);
                pfrm.add(lblDescr);
                pfrm.add(txtDescr);
                pfrm.add(lblSaldo);
                pfrm.add(txtSaldo);
                pfrm.add(new JLabel(""));
                pfrm.add(btn);

                //
                txtCodigo.setEnabled(false);
                try {
                    ResultSet rs = DataIO.getResultSet("SELECT COALESCE(MAX(IDC)+1,1) FROM TBL_CLIENTE");
                    if ( rs.next() ) {
                        txtCodigo.setText(rs.getString(1));
                    }
                    rs.close();
                } catch(SQLException sqle) {
                    txtCodigo.setText("1");
                }
                
                // events
                btn.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //validar
                        if ( !SwingUtil.chkText("Debe Ingresar una descripcion",txtDescr,1) ) return;
                        if ( SwingUtil.chkDouble("Debe Ingresar un saldo mayor que cero",txtSaldo) == null ) return;
                        //insertar cliente en b.d.
                        
                        if ( DataIO.executeQuery("INSERT INTO TBL_CLIENTE(IDC,DESCR,SALDO) VALUES("+txtCodigo.getText()+",'"+txtDescr.getText()+"',"+txtSaldo.getText()+")") ) {
                            DataIO.doCommit();
                            JOptionPane.showMessageDialog(null, "Cliente dado de Alta Ok!", "Info", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Error ["+DataIO.getErrorMessages()+"] al intentar dar de alta Cliente!", "Error BD", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                });
                
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pfrm,
                                                4, 2, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                                                
                pCenter.add(pfrm);
                refresh();
            }
        });

/**
 * Opcion de consulta 1 consulta muy basica sobre cliente
 */
        micli2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 1 de cliente!");
                removeComponent();
                JTable tbl = new JTable();
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
/***********************************************************************************
 *               EJEMPLO BASICO CON CLASE ANONIMA
 ***********************************************************************************                
                tbl.setModel(new AbstractTableModel() {
                    private ResultSet rs = null;
                    public int getRowCount() {
                        return 2;
                    }
                    public int getColumnCount() {
                        return 3;
                    }
                    public Object getValueAt(int row, int column) {
                        return ""+row+","+column;
                    }
                });
***********************************************************************************                                
*/                
                ClienteModel tblm = new ClienteModel(rs);
                tbl.setModel(tblm);
                pCenter.add(tbl);
                refresh();
            }
        });
/**
 * Opcion de consulta 2 que permite hacer abm simple sobre grilla y base de datos
 */
        micli3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 2 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel2 tblm = new ClienteModel2(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                pEste.setLayout(new GridLayout(5,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar();
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                refresh();
            }
        });
        
/**
 * Opcion de consulta 3 que permite hacer abm simple sobre grilla y base de datos
 */
        micli4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 3 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JButton btnGuardar = new JButton("Guardar");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel3 tblm = new ClienteModel3(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                btnGuardar.setEnabled(false);
                pEste.setLayout(new GridLayout(7,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnGuardar);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pEste.add(new JLabel(""));
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar(btnAlta,btnBaja,btnGuardar);
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                btnGuardar.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.guardar();
                    }
                });
                refresh();
            }
        });
/**
 * Opcion de nueva factura
 */
        mifac1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                removeComponent();
                JPanel pEste = new JPanel();
                JPanel pNorte = new JPanel(new SpringLayout());
                JPanel pSur = new JPanel(new SpringLayout());
                java.util.List<Producto> lst = Data.getProductos();
                java.util.List<Cliente> lstc = Data.getClientes();
                SwingUtil<Producto> sup = new SwingUtil<Producto>();
                SwingUtil<Cliente> suc = new SwingUtil<Cliente>();
                JComboBox<Producto> cp = sup.cmb(lst);
                JComboBox<Cliente> cc = suc.cmb(lstc);
                JFormattedTextField txtTotal = new JFormattedTextField(new DecimalFormat("###,###,###,##0.00"));
                txtTotal.setEditable(false);
                txtTotal.setValue(new Double(0.0));
                txtTotal.setPreferredSize(new Dimension(200,20));
                txtTotal.setHorizontalAlignment(SwingConstants.RIGHT); // alinear a la derecha
                txtTotal.setFont(new Font(null,Font.BOLD,12)); // font x defecto, en bold, y 12 pixels
                JTable tbl = new JTable();
                tbl.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                DetalleModel dm = new DetalleModel(txtTotal);
                dm.agregar();
                tbl.setModel(dm);
                tbl.setRowHeight(20);  // alto en pixel para todas las celdas, para que se visualice mejor la jcombobox
                SwingUtil.setColumnEditor(tbl,0,new DefaultCellEditor(cp));
                SwingUtil.setColumnWidth(tbl,0,300,100,300,300);
                SwingUtil.setColumnWidth(tbl,1,100,50,50,75);
                SwingUtil.setColumnWidth(tbl,2,100,50,50,75);
                SwingUtil.setColumnWidth(tbl,3,100,50,50,75);
                JButton btnAlta = new JButton("+");
                JButton btnBaja = new JButton("-");
                JButton btnGuardar = new JButton("Confirmar");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                scp.setPreferredSize(new Dimension(600,600));
                //fr.setSize(800,800);
                
                MyComboBoxRenderer<Producto> cbr = new MyComboBoxRenderer<Producto>(tbl,0,lst);
                SwingUtil.setColumnRenderer(tbl,0,cbr);
                // implementa runnable
                ThrFactura thrf = new ThrFactura(cbr,(MyComboModel<Cliente>) cc.getModel()); 
                Thread thr = new Thread(thrf);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                pEste.setLayout(new GridLayout(7,1));
                pSur.add(new JLabel("Total:"));
                pSur.add(txtTotal);
                pSur.add(btnGuardar);
                pNorte.add(new JLabel("Cliente:"));
                pNorte.add(cc);
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pSur,
                                                1, 3, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                SpringUtilities.makeCompactGrid(pNorte,
                                                1, 2, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pEste.add(new JLabel(""));
                //pCenter.add(scp);
                pNorth.add(pNorte);
                pCenter.add(scp);
                pEast.add(pEste);
                pSouth.add(pSur);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        dm.agregar();
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            dm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                btnGuardar.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        // validar
                        if ( cc.getSelectedIndex() == -1 ) {
                            JOptionPane.showMessageDialog(null, "Debe Seleccionar Cliente", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                        if ( ((Double) txtTotal.getValue()).doubleValue() <= 0.0 ) {
                            JOptionPane.showMessageDialog(null, "Debe Ingresar Productos a facturar", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                        // validacion OK!
                        // hacer commit para obtener la imagen mas reciente de la base de datos
                        DataIO.doCommit();
                        // averiguar cual es el ultimo numero de factura + 1
                        ResultSet rs = DataIO.getResultSet("SELECT (COALESCE(MAX(NRO),0)+1) AS UNRO FROM TBL_FACTURA");
                        try {
                            if ( rs.next() ) {
                                int nrofactura = rs.getInt("UNRO");
                                // insertar factura con fecha de hoy y estado 0
                                if ( DataIO.executeQuery("INSERT INTO TBL_FACTURA(NRO,FECHA,IDC,ESTADO,MONTO,PAGADA) " +
                                        "VALUES(" + nrofactura + ",'TODAY'," + ((Cliente) cc.getSelectedItem()).getIdc() +","+
                                        "'0',"+((Double) txtTotal.getValue()).doubleValue()+",'0')" )) {
                                    //factura inicialmente insertada Ok
                                    // insertar detalle
                                    for(Detalle dd : dm.getDetalle()) {
                                        DataIO.executeQuery("INSERT INTO TBL_DETALLE(NRO,IDP,CANTIDAD,PRECIO) VALUES("+
                                                nrofactura+","+dd.getProducto().getIdp()+","+dd.getCantidad()+","+dd.getPrecio()+")");
                                        // descontar stock
                                        DataIO.executeQuery("UPDATE TBL_PRODUCTO SET STOCK = STOCK - "+dd.getCantidad()+
                                            ",PRECIO_BASE = "+dd.getPrecio()+" WHERE IDP = "+dd.getProducto().getIdp() );
                                    }
                                    // sumar al saldo deudor del cliente
                                    DataIO.executeQuery("UPDATE TBL_CLIENTE SET SALDO = SALDO + "+((Double) txtTotal.getValue()).doubleValue()+" "+
                                        "WHERE IDC = "+((Cliente) cc.getSelectedItem()).getIdc());
                                    // pasar la factura a estado 1
                                    DataIO.executeQuery("UPDATE TBL_FACTURA SET ESTADO = '1' WHERE NRO = "+nrofactura);
                                    // hacer commit
                                    DataIO.doCommit();
                                    // mensaje de informacion indicando numero de factura realizada
                                    JOptionPane.showMessageDialog(null, "Factura ["+nrofactura+"] guardada Ok!", "Error de Validacion", JOptionPane.INFORMATION_MESSAGE);
                                } else {
                                    JOptionPane.showMessageDialog(null, "Error Insertando Cabecera de Factura ["+nrofactura+"] "+DataIO.getErrorMessages(), "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                                }
                            }
                            rs.close();
                        } catch(SQLException sqle) {
                            JOptionPane.showMessageDialog(null, "Error Insertando Factura. "+DataIO.getErrorMessages(), "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                });
                refresh();
                thr.start(); // lanzo el thread de facturacion!
            }
        });
        
        fr.setLocationRelativeTo(null); // centrado
        // PASO 7 CONFIGURAR EL TAMA#O DEL CONTENEDOR
        fr.setSize(500,400);
        // PASO 8 HACER EL CONTENEDOR VISIBLE
        fr.setVisible(true);
    }
    
    // windows events que nos interesan
    // sobre-escribo metodo windowClosed()
    @Override
    public void windowClosing(WindowEvent e) {
        ThrFactura.finalizo();
        log.cierroAplicacion();
    }

    private void removeComponent() {
        ThrFactura.finalizo();
        pNorth.removeAll();
        pSouth.removeAll();
        pEast.removeAll();
        pWest.removeAll();
        pCenter.removeAll();
    }
    private void refresh() {
        // refresh
        fr.pack();
        fr.invalidate();
        fr.validate();
    }
}
