
/**
 * Class Cliente , contiene desccripcion numero de cliente saldo,
 * para asociarlo a la factura y generar dicha factura.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cliente
{
    private int idc;  
    private String descripcion;
    private double saldo = 0;

    /**
     * Constructor for objects of class Cliente
     */
    public Cliente() {
         //Constructor null
         saldo = 0;
    }
    
    public Cliente(int idc) {
        // initialise instance variables
       this.idc = idc ; 
       saldo = 0;
    }
    
    public Cliente(String descripcion) {
        // initialise instance variables
       saldo = 0;
       this.descripcion = descripcion;
    }
    
    public Cliente(int idc,String descripcion) {
        // initialise instance variables
       saldo = 0;
       this.idc = idc;
       this.descripcion = descripcion;
    }
    
    public Cliente(int idc,String descripcion,double saldo) {
        // initialise instance variables
       this.idc = idc;
       this.descripcion = descripcion;
       this.saldo = saldo;
    }
    
    /**
     * @return    id cliente
     */
    public int getIdc() {
        return idc;
    }
    
    /**
     * @return  retorna  descripcion del cliente
     */
    public String getDescripcion()  {
   
        return descripcion;
    }
    
    /**
     * @return  retorna saldo del cliente
     */
    public double getSaldo() {
        return saldo;
    }
    
    /**
     * @param Ingreso de Idc de cliente
     */
    public void setIdc(int idcliente){
    
        this.idc = idcliente;
    }
    
    /**
     * @param Ingreso de descripcion de cliente
     */
    public void setDescripcion(String descripcion){
    
        this.descripcion = descripcion;
    }
    
    /**
     * 
     */
    private void setSaldo(double saldo){
        this.saldo += saldo;
    }
    
    /**
     * @param Ingreso de saldo de cliente, inicializado en cero
     */
    public void addSaldo(double saldo){
        setSaldo(saldo);
    }
    
    /**
     * Sobre escribe metodo toString para devolver en string todos sus campos correspondientes a cliente
     * @return String datos de cliente
     */
    @Override
    public String toString(){
        //return ">Idc : "+getIdc()+" >Descripcion : "+getDescripcion()+" >Saldo : "+getSaldo();
        return getDescripcion();
    }
    
    /**
     * Código que añadimos a la clase Cliente. Sobreescritura del método equals
     * @return true or false
     */
    @Override
    public boolean equals (Object obj) {
        if (obj == null){return false;}
        if (obj == this){return true; }
         else if ( (obj instanceof Cliente) && (((Cliente)obj).getIdc() == this.idc) ) {
                  return true;
                } else {return false; }
    }
    
    /**
     * Si el metodo hascode es invocado en multiples ocaciones durante la ejecucion de una aplicacion, este debe
     * regresar consistentemente el mismo valor entero.
     * Si dos objetos son iguales segun el  metodo equals entonces la llamada al metodo hash code debe regresar el
     * mismo hashcode.
     * 
     * El métodohashCode() de Cliente debe retornar el atributo idc
     * 
     */
    @Override
    public int hashCode(){
    return idc;
    }
}
