import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.*;
import java.util.*;
/**
 * Write a description of class MyComboBoxRenderer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyComboBoxRenderer<E> implements TableCellRenderer {
    private List<JComboBox<E>> cmbs = new ArrayList<JComboBox<E>>();
    private List<MyComboModel<E>> pms = new ArrayList<MyComboModel<E>>();
    private List<E> lst = null;
    private JTable tbl = null;
    private int columnIndex = 0;
    /**
     * Crea objeto de renderizacion de columna JComboBox sobre JTable
     * 
     * @param t JTable sobre la cual se hace renderizacion de columna con JComboBox
     * @param columnIdx numero de columna de la JTable sobre la cual se hace renderizacion
     * @param ls Lista (por lo general, ArrayList) de objetos de tipo E que se utilizara para crear las JComboBox que se
     * requieran a medida que se agregan filas en la tabla
     */
    public MyComboBoxRenderer(JTable t,int columnIdx,java.util.List<E> ls) {
        lst = ls;
        tbl = t;
        columnIndex=columnIdx;
    }
    public java.awt.Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,boolean hasFocus, int row, int column) {
        /*
        if (isSelected) {
            cmb.setForeground(table.getSelectionForeground());
            cmb.setBackground(table.getSelectionBackground()); //super
        } else {
            cmb.setForeground(table.getForeground());
            cmb.setBackground(table.getBackground());
        }
        */
       if ( tbl == null ) tbl=table;
       if ( row < cmbs.size() ) {
            cmbs.get(row).setSelectedItem(value);
        } else {
            SwingUtil<E> su = new SwingUtil<E>();
            cmbs.add(su.cmb(lst));
            pms.add((MyComboModel<E>) cmbs.get(row).getModel());
            SwingUtil.setColumnEditor(tbl,columnIndex,new DefaultCellEditor(su.cmb(lst)));
        }
        return cmbs.get(row);
    }
    
    // CUSTOM
    public synchronized void setList(List<E> l) {
        System.out.println("MyComboBoxRenderer.setList(): Lista actual:");
        for(E e:lst) System.out.println(e);
        System.out.println("MyComboBoxRenderer.setList(): Lista nueva:");
        for(E e:l) System.out.println(e);

        // actualizo la lista de tipo E utilizada para crear las nuevas combos a medida 
        // que se agregan filas a la JTableget
        lst=l;
        // actualizar los combos models con la nueva lista de tipo E
        for(MyComboModel<E> mo : pms) {
            mo.setList(l);
        }
        
        // indicarle a las combos los actuales combo models previamente modificados
        for(int i=0;i < cmbs.size();i++) {
            cmbs.get(i).setModel(pms.get(i));
        }
        // actualizo el editor de celdas de la columna 0 de la JTable
        SwingUtil<E> su = new SwingUtil<E>();
        SwingUtil.setColumnEditor(tbl,0,new DefaultCellEditor(su.cmb(lst)));
    }
    public List<E> getList() { return lst; }
}

